/**********************************************************
Mp3teg reader
Written  by Strelok Vlad Kolerts
Powered by T3D
19/01/2009
Email: admin@mobsk.org.ua
ICQ: 497123239
***********************************************************/

#include "mp3teg.h"


mp3teg::mp3teg(QString path):QWidget(NULL, "mp3teg")
	{
		
		char* s;
		Tag=true;
		/*QString path="/mmc/mmca1/Music/drum_and_bass-samyiy_grustnyiy_dram__(audiovkontakte).mp3"; //*/
		unsigned long end_file=QFileInfo ( path ).size();
		QFile file(path);
		if( file.open(IO_ReadOnly) )		
		{
			QDataStream stream( &file );
			qDebug("Path = "+path);
			/*int tmp_end_file=(end_file-128);
			for(int i=65536;i<tmp_end_file;i=i+65536)
			{
				s = new char[65536];
				stream.readRawBytes(s,65536);
			}
			tmp_end_file=tmp_end_file%65536;
			if(tmp_end_file==0)	tmp_end_file=tmp_end_file+65536;
			//
			if(tmp_end_file>=4096)
			{
				qDebug(QString("tmp_end_file=%1").arg(tmp_end_file));
				for(int i=4096;i<tmp_end_file;i=i+4096)
				{
					s = new char[4096];
					stream.readRawBytes(s,4096);
				}
				tmp_end_file=tmp_end_file%4096;
				if(tmp_end_file==0)	tmp_end_file=tmp_end_file+4096;
				//
				if(tmp_end_file>=1024)
				{
					qDebug(QString("tmp_end_file=%1").arg(tmp_end_file));
					for(int i=1024;i<tmp_end_file;i=i+1024)
					{
						s = new char[1024];
						stream.readRawBytes(s,1024);
					}
					tmp_end_file=tmp_end_file%1024;
					if(tmp_end_file==0)	tmp_end_file=tmp_end_file+1024;
					//
					if(tmp_end_file>=128)
					{
						qDebug(QString("tmp_end_file=%1").arg(tmp_end_file));
						for(int i=128;i<tmp_end_file;i=i+128)
						{
							s = new char[128];
							stream.readRawBytes(s,128);
						}
						tmp_end_file=(tmp_end_file%128);
						if(tmp_end_file==0)	tmp_end_file=tmp_end_file+128;
						//
						if(tmp_end_file>=32)
						{
							qDebug(QString("tmp_end_file=%1").arg(tmp_end_file));
							for(int i=32;i<tmp_end_file;i=i+32)
							{
								s = new char[32];
								stream.readRawBytes(s,32);
							}
							tmp_end_file=(tmp_end_file%32);
							if(tmp_end_file==0)	tmp_end_file=tmp_end_file+32;
							qDebug(QString("tmp_end_file=%1").arg(tmp_end_file));
						}
					}
				}
			}
			tmp_end_file=tmp_end_file+128;*/
			///stream.device()->at(end_file-128);
			qApp -> processEvents();
			s = new char[end_file-128];
			stream.readRawBytes(s, end_file-128);
			qApp -> processEvents();
			char* ss=s;
			
///READ ARTIST TITLE ALBUM YEAR COMMENT GENRE	
		
			for(int i=0;i<128;i++)
			{
                stream.readRawBytes(s,1);
				if(s[0]==00 or s[0]==255) continue;
				
				//qDebug(QString("s=%1").arg(s[0]));
				if (i==0	&& s[0]!=84)	{Tag=false;break;}
				
				if (Tag)
				{
					if (i>=3	&& i<=32)		{inf_title+=QString("%1").arg(s[0]);}
					if (i>=33	&& i<=62)		{inf_artist+=QString("%1").arg(s[0]);}
					if (i>=63	&& i<=92)		{inf_album+=QString("%1").arg(s[0]);}
					if (i>=93	&& i<=96)		{inf_year+=QString("%1").arg(s[0]);}
					if (i>=97	&& i<=124)		{inf_comment+=QString("%1").arg(s[0]);}
					if (i==127)					id_genre=s[0];
				}
			}
			qApp -> processEvents();
			if(Tag)
			{
				QString name_genre[148] =
				{
					"Blues",	"Classic Rock",	"Country",	"Dance",	"Disco",	"Funk",	"Grunge",	"Hip-Hop",	"Jazz",
					"Metal","New Age",	"Oldies",	"Other",	"Pop",	"R&B",	"Rap",	"Reggae",	"Rock",	"Techno",
					"Industrial",	"Alternative",	"Ska",	"Death Metal",	"Pranks",	"Soundtrack",	"Euro-Techno",
					"Ambient",	"Trip-Hop",	"Vocal",	"Jazz+Funk",	"Fusion",	"Trance",	"Classical",	"Instrumental",
					"Acid",	"House",	"Game",	"Sound Clip",	"Gospel",	"Noise",	"Alt. Rock",	"Bass",	"Soul",	"Punk",
					"Space",	"Meditative",	"Instrumental Pop",	"Instrumental Rock",	"Ethnic",	"Gothic",	"Darkwave",
					"Techno-Industrial",	"Electronic",	"Pop-Folk",	"Eurodance",	"Dream",	"Southern Rock",	"Comedy",
					"Cult",	"Gangsta Rap",	"Top 40",	"Christian Rap",	"Pop/Funk",	"Jungle",	"Native American",	"Cabaret",
					"New Wave",	"Psychedelic",	"Rave",	"Showtunes",	"Trailer",	"Lo-Fi",	"Tribal",	"Acid Punk",
					"Acid Jazz",	"Polka",	"Retro",	"Musical",	"Rock & Roll",	"Hard Rock",	"Folk",	"Folk/Rock",
					"National Folk",	"Swing",	"Fast-Fusion",	"Bebob",	"Latin",	"Revival",	"Celtic",	"Bluegrass",
					"Avantgarde",	"Gothic Rock",	"Progressive Rock",	"Psychedelic Rock",	"Symphonic Rock",	"Slow Rock",
					"Big Band",	"Chorus",	"Easy Listening",	"Acoustic",	"Humour",	"Speech",	"Chanson",	"Opera",
					"Chamber Music",	"Sonata",	"Symphony",	"Booty Bass",	"Primus",	"Porn Groove",	"Satire",
					"Slow Jam",	"Club",	"Tango",	"Samba",	"Folklore",	"Ballad",	"Power Ballad",	"Rhythmic Soul",
					"Freestyle",	"Duet",	"Punk Rock",	"Drum Solo",	"A Cappella",	"Euro-House",	"Dance Hall",
					"Goa",	"Drum & Bass",	"Club-House",	"Hardcore",	"Terror",	"Indie",	"BritPop",	"Negerpunk",
					"Polsk Punk",	"Beat",	"Christian Gangsta Rap",	"Heavy Metal",	"Black Metal",	"Crossover",
					"Contemporary Christian",	"Christian Rock",	"Merengue",	"Salsa",	"Thrash Metal",	"Anime",
					"JPop",	"Synthpop"
				};
				
				if(id_genre>147)	inf_genre="Unknown";
				else			inf_genre=name_genre[id_genre];
				
				qDebug(" Title = "+inf_title);
				qDebug(" Artist = "+inf_artist);
				qDebug(" Album = "+inf_album);
				qDebug(" Year = "+inf_year);
				qDebug(" Genre = "+inf_genre);
				qDebug(" Comment = "+inf_comment);
			}
			else
				qDebug(QString("Error: can not read tags"));
				
///READ BITRATE HZ CHANELS
				
				QString name_bit_rate[16] =
				{
					"0",	"32",	"40",	"48",	"56",	"64",	"80",	"96",
					"112",	"128",	"160",	"192",	"224",	"256",	"320",	"---"
				};
				
				QString name_bit_rate2[16] =
                {
                    "0",    "8",    "16",    "24",    "32",    "40",    "48",    "56",
                    "64",    "80",    "96",    "112",    "128",    "144",    "160",    "---"
                };
				
				QString name_chastota[4] =
				{
					"44100",    "48000",    "32000",    "-----"
				};
				QString name_chastota2[4] =
                {
                    "22050",    "24000",    "16000",    "-----"
                };
				
				QString name_MonoStereo[4] =
				{
					"Stereo",    "Joint stereo",    "Dual channel",    "Mono"
				};
				
				bit_rate=name_bit_rate[15];
				chastota=name_chastota[3];
				MonoStereo="Unknown";
				
				char inf1, inf2, inf3, inf4;
				qApp -> processEvents();
				if ( ss[1]!=68 && ss[3]!=51) 
				{
					inf1=255;
					inf2=ss[1];
					inf3=ss[2];
					inf4=ss[3];
				}
				else
				{
					for(int i=0;i<end_file-128;i++)
					{
					  if (ss[i]==255) 
                        {
							if (ss[i+1]==242 or ss[i+1]==243 or ss[i+1]==250 or ss[i+1]==251)
							{
								inf1=ss[i];
								inf2=ss[i+1];
								inf3=ss[i+2];
								inf4=ss[i+3];
								break;
							}
                        }  
                    }
                }
				char bb=inf2;
                bb = bb >> 4;
                if ((inf1==255 && bb==15))
                {
                    bb=inf2;
                    bb = bb << 4;
                    bb = bb >> 7;
                    char aa=inf3;
                    aa = aa >> 4;
                    if(aa>14) bit_rate=name_bit_rate[15];
                    else
					{
						if(bb)
							bit_rate=name_bit_rate[(int)aa];
                        else
							bit_rate=name_bit_rate2[(int)aa];
                    }
                    aa=inf3;
                    aa = aa << 4; 
                    aa = aa >> 6; 
                    if(aa>2)    chastota=name_chastota[3];
                    else
					{
						if(bb)
							chastota=name_chastota[(int)aa];    
                        else
							chastota=name_chastota2[(int)aa];
                    }
                    aa=inf4;
                    aa = aa >> 6; 
                    
                    MonoStereo=name_MonoStereo[(int)aa];
                }
				
				qDebug(" Bitrate= "+bit_rate);
				qDebug(" Chastota= "+chastota);
				qDebug(" Chanels= "+MonoStereo);
				
				//qDebug(QString("end_file= %1").arg(end_file));
			
			file.close();
		}
		else 
		{
			qDebug("Error: can not open "+path);
		}		
	}
